#include <time.h>
#include "load.h"

static long loops_per_second = 30000;

void eat (float for_seconds)
{
    long num_loop = (long)(loops_per_second * (float)for_seconds);
    long j = 1;
    long i;
  
    for (i=1; i<=num_loop; i++) {
        j++;
        if (j<i) {
            j = i-j;
        } else {
            j = j-1;
        }
    }
}

long subtract (struct timespec *a, struct timespec *b)
{
    long result, nanos;

    result = (a->tv_sec  - b->tv_sec)*1000000;
    nanos  = (a->tv_nsec - b->tv_nsec)/1000;
    return (result+nanos);
}


void adjust (void)
{
    struct timespec initial_time, final_time;
    long interval;
    int number_of_tries =0;
    long adjust_time = 1000000;
    int max_tries = 6;

    do {
        clock_gettime (CLOCK_REALTIME, &initial_time);
        eat(((float)adjust_time)/1000000.0);
        clock_gettime (CLOCK_REALTIME, &final_time);
        interval = subtract(&final_time,&initial_time);
        loops_per_second = (long)( 
       	      (float)loops_per_second*(float)adjust_time/(float)interval);
        number_of_tries++;
    } while (number_of_tries<=max_tries &&
	     labs(interval-adjust_time)>=adjust_time/50);
}


